--
--  TONE_GENERATOR.vhd
--
--  Generator a tone.
--
--        Copyright (C)2001 - 2002 SEILEBOST
--                   All rights reserved.
--
-- $Id: TONE_GENERATOR.vhd, v0.1 2002/30/04 00:00:00 SEILEBOST $
--
-- Generate a signal with an frequency is equal at f = fRef/(2 * N)

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity TONE_GENERATOR is
    Port ( CLK        : in     std_logic;
           RST        : in     std_logic;
           LD_TONE    : in     std_logic;
           FRQ_TONE_H : in     std_logic_vector(3 downto 0);
           FRQ_TONE_L : in     std_logic_vector(7 downto 0);
           OUT_TONE   : inout  std_logic );
end TONE_GENERATOR;

architecture Behavioral of TONE_GENERATOR is

SIGNAL COUNT : std_logic_vector(11 downto 0);

BEGIN

 PROCESS(CLK, RST)
 BEGIN
      if (RST = '1') then
         OUT_TONE <= '0';
         COUNT    <= "000000000000";
      elsif rising_edge(CLK) then                   
            if (LD_TONE = '1' OR count = "000000000000") then
                COUNT    <= FRQ_TONE_H & FRQ_TONE_L;
                OUT_TONE <= NOT OUT_TONE;
            ELSE 
                COUNT <= COUNT - 1;
            end if;
      end if;
 end process; 

end Behavioral;
